Algorithm


Problem - Remove duplicates from sorted array

URL - https://leetcode.com/problems/remove-duplicates-from-sorted-array/

Level - Beginner

Details

Given an integer array nums sorted in non-decreasing order, remove the duplicates in-place such that each unique element appears only once. The relative order of the elements should be kept the same.

Since it is impossible to change the length of the array in some languages, you must instead have the result be placed in the first part of the array nums. More formally, if there are k elements after removing the duplicates, then the first k elements of nums should hold the final result. It does not matter what you leave beyond the first k elements.

Return k after placing the final result in the first k slots of nums.

Do not allocate extra space for another array. You must do this by modifying the input array in-place with O(1) extra memory.

Custom Judge:

The judge will test your solution with the following code:

int[] nums = [...]; // Input array
int[] expectedNums = [...]; // The expected answer with correct length

int k = removeDuplicates(nums); // Calls your implementation

assert k == expectedNums.length;
for (int i = 0; i < k; i++) {
    assert nums[i] == expectedNums[i];
}

If all assertions pass, then your solution will be accepted.

 

Example 1:

Input: nums = [1,1,2]
Output: 2, nums = [1,2,_]
Explanation: Your function should return k = 2, with the first two elements of nums being 1 and 2 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2:

Input: nums = [0,0,1,1,1,2,2,3,3,4]
Output: 5, nums = [0,1,2,3,4,_,_,_,_,_]
Explanation: Your function should return k = 5, with the first five elements of nums being 0, 1, 2, 3, and 4 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

 

Constraints:

  • 1 <= nums.length <= 3 * 104
  • -100 <= nums[i] <= 100
  • nums is sorted in non-decreasing order.

 

Code Examples

#1 Code Example with Javascript Programming

Code - Javascript Programming


/**
 * Remove duplicates from array.
 *
 * @param {number[]} nums
 *
 * @return {number}
 */
var removeDuplicates = function(nums) {
  const hashMap = {};
  let totalFound = 0;

  for (let i = 0; i  <  nums.length; i++) {
    let num = nums[i];

    if (!(num in hashMap)) {
      hashMap[num] = i;

      // Store total found
      totalFound++;

      // Modify the array
      nums[totalFound - 1] = num;
    }
  }

  return totalFound;
};
Copy The Code & Try With Live Editor

Input

x
+
cmd
[0,0,1,1,1,2,2,3,3,4]

Output

x
+
cmd
5

#2 Code Example with C Programming

Code - C Programming


int removeDuplicates(int* nums, int numsSize) {
    int i, j;

    if (numsSize  <  2) return numsSize;

    for (i = 0, j = 1; j  <  numsSize; j ++) {
            if (nums[j] != nums[i]) {
            i ++;
            nums[i] = nums[j];
         }
     }

    return i + 1;
}
Copy The Code & Try With Live Editor

Input

x
+
cmd
[1,1,2]

Output

x
+
cmd
2

#3 Code Example with C++ Programming

Code - C++ Programming


class Solution {
public:
    int removeDuplicates(vector<int>& nums) {
        int i = 0, j = 0;
        while(j  <  nums.size()){
            while(j < nums.size() - 1 && nums[j] == nums[j + 1]) j++;
            nums[i++] = nums[j++];
        }
        return i;
    }
};
Copy The Code & Try With Live Editor

Input

x
+
cmd
[0,0,1,1,1,2,2,3,3,4]

Output

x
+
cmd
5

#4 Code Example with C# Programming

Code - C# Programming


namespace LeetCode
{
    public class _026_RemoveDuplicatesFromSortedArray
    {
        public int RemoveDuplicates(int[] nums)
        {
            if (nums.Length <= 1) { return nums.Length; }

            var index = 0;
            var lastValue = nums[index];
            for (int i = 0; i  <  nums.Length; i++)
            {
                if (nums[i] == lastValue) { continue; }

                nums[++index] = nums[i];
                lastValue = nums[index];
            }

            return index + 1;
        }
    }
}

Copy The Code & Try With Live Editor

Input

x
+
cmd
[1,1,2]

Output

x
+
cmd
2

#5 Code Example with Java Programming

Code - Java Programming


class Solution {
  public int removeDuplicates(int[] nums) {
    int startIdx = 0;
    int endIdx = 0;
    while (endIdx  <  nums.length) {
      int currValue = nums[endIdx];
      while (endIdx < nums.length && nums[endIdx] == currValue) {
        endIdx++;
      }
      nums[startIdx++] = currValue;
    }
    return startIdx;
  }
}
Copy The Code & Try With Live Editor

Input

x
+
cmd
[1,1,2]

Output

x
+
cmd
2

#6 Code Example with Python Programming

Code - Python Programming


class Solution:
    def removeDuplicates(self, nums):
        n = len(nums)
        return n - len([nums.pop(i) for i in range(n -1, 0, -1) if nums[i] == nums[i - 1]])
Copy The Code & Try With Live Editor

Input

x
+
cmd
[0,0,1,1,1,2,2,3,3,4]

Output

x
+
cmd
5
Advertisements

Demonstration


Leetcode - Remove duplicates from sorted array Solution in JavaScript Leetcode

Previous
#25 Leetcode Reverse Nodes in k-Group Solution in C, C++, Java, JavaScript, Python, C# Leetcode
Next
#27 Leetcode - Remove Element Problem solution in Javascript, C, C++, C#, Java, Python